# -*- coding: UTF-8 -*-
import os
import json
import platform
import subprocess
import linecache

def run_cmd(cmdinfo):
    print cmdinfo
    ret = subprocess.Popen(cmdinfo, env=os.environ, shell=True, stdout=subprocess.PIPE, stderr=subprocess.PIPE, stdin=subprocess.PIPE)
    return ret
def get_os_version():
    os_version=platform.platform().lower()
    return os_version

def check_upgrade_runnable():
    ret = run_cmd('chmod +x /usr/local/hostguard/sudobin/upgrade && /usr/local/hostguard/sudobin/upgrade --help')
    is_runnable = True
    if (len(ret.stderr.read()) != 0) and (len(ret.stdout.read()) == 0):
        is_runnable = False
    return is_runnable

def check_patchelf_exist():
    patchelf='/tmp/upgradeful/tmp/patchelf'
    
    return os.path.exists(patchelf)

def download_patchelf(os_arch):
    connect_addr=linecache.getline(r'/usr/local/hostguard/conf/connect.conf', 1).split("=")[1].replace('\n','').replace('\r','')
    patchelf_path = '/tmp/patchelf'
    download_url = 'https://'+connect_addr + '/package/upgrade/linux/agent2.0/patchelf/' + os_arch + '/patchelf'
    run_cmd('curl -k {url} -o /tmp/patchelf'.format(url=download_url))
    return patchelf_path
def do_fix_upgrade_elf(patchelf_path, os_arch):
    fix_dir = '/usr/local/hostguard/sudobin/upgrade'
    lib_dir = '/usr/local/hostguard/lib'
    interpreter='ld-linux-aarch64.so.1'
    if os_arch == 'x86_64':
        interpreter='ld-linux-x86-64.so.2'
    
    ret=run_cmd('chmod +x {exe} && {exe} --force-rpath --set-rpath {lib} {target} && {exe} --set-interpreter {lib}/{so} {target}'.format(exe=patchelf_path, lib=lib_dir, target=fix_dir, so=interpreter))
    return ret
def clean_env(elfpath):
    run_cmd=('rm -rf {elf}'.format(elf = elfpath))

    return 

def get_tags():
    return ['1','1.0']

def run_task(runcontext):
    os_version = get_os_version()
    support_version = ['centos-6', 'suse-11']
    ret_code = 0
    ret_msg = ''
    os_arch = platform.machine()
    if os_arch != 'x86_64':
        os_arch = 'aarch64'
    if ('centos-6' not in os_version) and ('suse-11' not in os_version):    
        return ret_code,'high version'
    
    if (check_upgrade_runnable()):
        return ret_code,'upgrade normal'
    
    if (check_patchelf_exist() is False):
        elfpath = download_patchelf(os_arch)
        do_fix_upgrade_elf(elfpath,os_arch)
        clean_env(elfpath)
        ret_msg='fix success'
        return ret_code, ret_msg

    do_fix_upgrade_elf('/tmp/upgradeful/tmp/patchelf', os_arch)
        
    return ret_code,ret_msg
