# -*- coding: UTF-8 -*-

import re

def get_tags():
    return ['1','1.10']

def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate = runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["systemvalue1"] = ""
    ret_code = 0
    ret_msg = []
    checkFlag = False
 
    
    try:
        f = None
        f = open(r'/etc/ssh/sshd_config','r')
        if f is not None:
            lines = f.readlines()
            i = 0
            for line in lines:
                m = re.match(r"(?P<ciphers>^\s*[Cc][Ii][Pp][Hh][Ee][Rr][Ss])(?P<blank>\s+)(?P<alggroup>.+)", line)
                if m:
                    i = i + 1
                    # only the firt configured directive is checked
                    if i > 1:
                        break
                    str1 = m.group('alggroup').strip()
                    # delete comments end with the directive
                    if -1 != str1.find('#'):
                        str1 = str1[0:str1.find('#')]
                    l = str1.split(',')
                    # delete duplicate directive
                    l = list(set(l))
                    checkFlag = False
                    ret_msg.extend(l)
                    if 3 >= len(l) and 0 < len(l):
                        checkFlag = True
                        for x in l:
                            if x not in ['aes128-ctr','aes192-ctr','aes256-ctr']:
                                checkFlag = False
                                break
    except IOError as e:
        return (-2,"Failed to read /etc/ssh/sshd_config:%s"%str(e))
    finally:
        if f:
            f.close()
    
    tmp_vars["systemvalue1"] = 'Ciphers ' + ",".join(ret_msg)
    if checkFlag:
        ret_code = 0
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"
    else:
        ret_code = -1
        if 0 == i:
            tmp_vars["systemvalue1"] = "Ciphers aes128-ctr,aes192-ctr,aes256-ctr,arcfour256,arcfour128,aes128-gcm@openssh.com,aes256-gcm@openssh.com,aes128-cbc,3des-cbc,blowfish-cbc,cast128-cbc,aes192-cbc,aes256-cbc,arcfour"

    rc,out=curtemplate.render(runcontext.get_template_file('t_1_10.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)

    return ret_code,out
