# -*- coding: UTF-8 -*-

import re

def get_tags():
    return ['1','1.11']
    

def run_task(runcontext):
    rc,out=run_audit(runcontext)
    return rc,out

def run_audit(runcontext):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["systemvalue1"] = ""
    ret_code = 0
    ret_msg = []
    checkFlag = False
    
    
    try:
        f = None
        f = open(r'/etc/ssh/sshd_config','r')
        if f is not None:
            lines = f.readlines()
            i = 0
            for line in lines:
                m = re.match(r"(?P<macs>^\s*[Mm][Aa][Cc][Ss])(?P<blank>\s+)(?P<alggroup>.+)", line)
                if m:
                    i = i + 1
                    # only the firt configured directive is checked
                    if i > 1:
                        break
                    str1 = m.group('alggroup').strip()
                    # delete comments end with the directive
                    if -1 != str1.find('#'):
                        str1 = str1[0:str1.find('#')]
                    l = str1.split(',')
                    # delete duplicate directive
                    l = list(set(l))
                    checkFlag = False
                    ret_msg.extend(l)
                    if 2 >= len(l) and 0 < len(l):
                        checkFlag = True
                        for x in l:
                            if x not in ['hmac-sha2-512','hmac-sha2-256']:
                                checkFlag = False
                                break
    except IOError as e:
        return -2,str(e)
    finally:
        if f:
            f.close()
    
    tmp_vars["systemvalue1"] = "MACs " + ",".join(ret_msg)
    if checkFlag:
        ret_code = 0
        tmp_vars["policyresult"] = "pass"
        tmp_vars["checkresult1"] = "pass"
    else:
        ret_code = -1
        if 0 == i:
            tmp_vars["systemvalue1"] = "MACs hmac-md5-etm@openssh.com,hmac-sha1-etm@openssh.com,umac-64-etm@openssh.com,umac-128-etm@openssh.com,hmac-sha2-256-etm@openssh.com,hmac-sha2-512-etm@openssh.com,hmac-ripemd160-etm@openssh.com,hmac-sha1-96-etm@openssh.com,hmac-md5-96-etm@openssh.com,hmac-md5,hmac-sha1,umac-64@openssh.com,umac-128@openssh.com,hmac-sha2-256,hmac-sha2-512,hmac-ripemd160,hmac-sha1-96,hmac-md5-96"

    rc,out=curtemplate.render(runcontext.get_template_file('t_1_11.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)

    return ret_code,out
