# -*- coding: UTF-8 -*-

import re
import json

def get_tags():
    return ['1','1.12']

def run_task(runcontext):
    ansible_params=runcontext.get_mod_params_instance()
    runcontext.set_mod_params_instance(ansible_params,"chdir",None)
    runcontext.set_mod_params_instance(ansible_params,"executable",None)

    module=runcontext.get_module_file("shell.py")
    rc,out=run_audit(runcontext,ansible_params,module)
    return rc,out

def run_audit(runcontext,ansible_params,module):
    curtemplate=runcontext.get_template()
    tmp_vars = {}
    tmp_vars["policyresult"] = "failed"
    tmp_vars["checkresult1"] = "failed"
    tmp_vars["scancommand1"] = r'''result=$(sed -n '1,/^\s*Match/ p' /etc/ssh/sshd_config|grep "^[[:blank:]]*ClientAliveInterval" | awk '{print $NF}');result=$(echo $result | awk '{print $NF}');if [ -z "$result" ];then echo "ClientAliveInterval 0 ";elif [ "$result" -le "300" -a "$result" -gt "0" ];then echo ClientAliveInterval $result;else echo ClientAliveInterval "$result ";fi;'''
    tmp_vars["systemvalue1"] = ""
    tmp_vars["checkresult2"] = "failed"
    tmp_vars["scancommand2"] = r'''result=$(sed -n '1,/^\s*Match/ p' /etc/ssh/sshd_config|grep "^[[:blank:]]*ClientAliveCountMax" | awk '{print $NF}');result=$(echo $result | awk '{print $NF}');if [ -z "$result" ];then echo "ClientAliveCountMax 3";elif [ "$result" -le "3" -a "$result" -ge "0" ]; then echo ClientAliveCountMax $result;else echo ClientAliveCountMax "$result ";fi;'''
    tmp_vars["systemvalue2"] = ""
    ret_code = 0

    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand1"])
    arc1,astdout1,astderr1=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc1,astdout1,astderr1)
    runcontext.sleep()
    runcontext.set_mod_params_instance(ansible_params,"command",tmp_vars["scancommand2"])
    arc2,astdout2,astderr2=runcontext.invoke_module(module,ansible_params)
    runcontext.log_debug_invoke_result(arc2,astdout2,astderr2)
    runcontext.sleep()
    if arc1 != 0:
        return (-2, "Failed to invoke module: %s."%astdout1)

    resultjson1 = json.loads(astdout1)
    astdout1 = resultjson1["stdout"]
    astderr1 = resultjson1["stderr"]

    match1_found=re.match(r"^\s*ClientAliveInterval\s*\d+$",astdout1)
    if match1_found == None:
        tmp_vars["systemvalue1"] = astdout1
    else:
        tmp_vars["checkresult1"] = "pass"
        tmp_vars["systemvalue1"] = astdout1
        
    if arc2 != 0:
        return (-2, "Failed to invoke module: %s."%astdout2)

    resultjson2 = json.loads(astdout2)
    astdout2 = resultjson2["stdout"]
    astderr2 = resultjson2["stderr"]

    match2_found=re.match(r"^\s*ClientAliveCountMax\s*\d+$",astdout2)
    if match2_found == None:
        tmp_vars["systemvalue2"] = astdout2
    else:
        tmp_vars["checkresult2"] = "pass"
        tmp_vars["systemvalue2"] = astdout2

    if tmp_vars["checkresult2"] == "pass" and tmp_vars["checkresult1"] == "pass":
        ret_code = 0
        tmp_vars["policyresult"]="pass"
    else:
        ret_code = -1

    rc,out=curtemplate.render(runcontext.get_template_file('t_1_12.j2'),**tmp_vars)

    if rc == False:
        return (-2,"Failed to render template.%s" % out)

    return ret_code,out
